//+------------------------------------------------------------------+
//|                                                      Big Dog.mq4 |
//|                                                Copyright  2009. |
//|                                           http://strategy4you.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2009."
#property link      "http://strategy4you.ru"
extern int          Algoritm=0;   //   :
                                  // 0-      
                                  // 1-  ,       
extern double       Lot=0.0;      //  ( 0 -  )
extern int          MaxRisk=2;    // %   (  )
extern int          TakeProfit=30;// ( 0 -   )
extern int          StartTime=16; //   ( )
extern int          EndTime=18;   //   ( )
extern int          NoTrade=60;   // -     ( 0 -  )
extern bool         Warn=true;    //   
string StrategyName="Big Dog";
int    Magic=20090908;
bool   work=true;
int    day=0;
int    StopLoss=0;
//+------------------------------------------------------------------+
int init()
{if(Period()!=PERIOD_M15)
   {Alert("      M15!");work=false;}
 if(StartTime<0 || StartTime>23)
   {Alert("    !");work=false;}
 if(EndTime<0 || EndTime>23)
   {Alert("    !");work=false;}
 if(Algoritm!=0 && Algoritm!=1)
   {Alert("   !");work=false;}
 if(TakeProfit!=0 && TakeProfit<MarketInfo(Symbol(),MODE_STOPLEVEL))
   {Alert("   !");work=false;}
 if(StopLoss!=0 && StopLoss<MarketInfo(Symbol(),MODE_STOPLEVEL))
   {Alert("   !"); work=false;}
 if(Lot!=0 && Lot<MarketInfo(Symbol(),MODE_MINLOT))
   {Alert("   !"); work=false;}
 if(Lot!=0 && Lot>MarketInfo(Symbol(),MODE_MAXLOT))
   {Alert("   !"); work=false;}
 if(Lot==0 && MaxRisk<1)
   {Alert("  %      !"); work=false;}
 if(Lot==0 && MaxRisk>100)
   {Alert("  %      !"); work=false;}
return(0);}
//+------------------------------------------------------------------+
int deinit() {Comment(""); return(0);}
//+------------------------------------------------------------------+
int start()
{if(!work) {Comment("  !  ."); return(0);}
 if(DayOfWeek()==0 || DayOfWeek()==6) return(0); //    
 if(!IsTradeAllowed()) return(0); //     
 double mLot=Lot;
 if(Lot==0.0) mLot=GetOptimalLot(MaxRisk);
 Comment("http://strategy4you.ru");
//...  
 if(TimeHour(TimeCurrent())==StartTime)
   for(int i=0;i<OrdersTotal();i++)
     if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
       if(OrderSymbol()==Symbol() && OrderMagicNumber()==Magic)
         if(OrderType()==OP_BUYSTOP || OrderType()==OP_SELLSTOP)
           DelOrder();
//...  
 if(TimeHour(iTime(NULL,0,1))==EndTime && day!=TimeDay(TimeCurrent()))
   {day=TimeDay(TimeCurrent());//    
    int cbar=60/Period()*(EndTime-StartTime)+1;
    double h=High[iHighest(NULL,0,MODE_HIGH,cbar,1)];
    double l=Low[iLowest(NULL,0,MODE_LOW,cbar,1)];
    
    double level=MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
    string error;
    if((h-Ask)<level) 
      {error="     !   .";
       if(Warn) Alert(error);
       Print(error);
       h=Ask+level;}
    if((Bid-l)<level)
      {error="     !   .";
       if(Warn) Alert(error);
       Print(error);
       l=Bid-level;}
    StopLoss=(h-l)*MathPow(10,Digits);
    if(NoTrade!=0 && StopLoss>NoTrade)
      {error=" : "+StopLoss+"  : "+NoTrade+"!  .";
       if(Warn) Alert(error);
       Print(error);
       return(0);}
       
    if(TakeProfit>0)
      {NewOrder(OP_BUYSTOP,mLot,h,h+TakeProfit*Point,l);
       NewOrder(OP_SELLSTOP,mLot,l,l-TakeProfit*Point,h);}
    else
      {NewOrder(OP_BUYSTOP,mLot,h,0,l);
       NewOrder(OP_SELLSTOP,mLot,l,0,h);}
   }
//...
return(0);}
//+------------------------------------------------------------------+
int NewOrder(int Cmd,double lot,double pr=0,double tp=0,double sl=0)
{int tick=0;
 double a=0,b=0;
 for(int er=0;er<3;er++)
   {while(!IsTradeAllowed()) Sleep(100);
    a=MarketInfo(Symbol(),MODE_ASK);
    b=MarketInfo(Symbol(),MODE_BID);
    if(pr==0)
      {if(Cmd==OP_BUY) pr=a;
       if(Cmd==OP_SELL) pr=b;}
    if(Algoritm==0)
      {if(StopLoss>0 && sl==0)
         {if(Cmd==OP_BUY) sl=a-StopLoss*Point;
          if(Cmd==OP_SELL) sl=b+StopLoss*Point;}
       if(TakeProfit>0 && tp==0)
         {if(Cmd==OP_BUY) tp=a+TakeProfit*Point;
          if(Cmd==OP_SELL) tp=b-TakeProfit*Point;}
       tick=OrderSend(Symbol(),Cmd,lot,pr,3,sl,tp,StrategyName,Magic,0,CLR_NONE);
       if(tick>0) break;}
    if(Algoritm==1)
      {if(tick==0) tick=OrderSend(Symbol(),Cmd,lot,pr,3,0,0,StrategyName,Magic,0,CLR_NONE);
       if(tick>0)
         {while(!IsTradeAllowed()) Sleep(100);
          if(OrderSelect(tick,SELECT_BY_TICKET))
            {if(StopLoss>0 && sl==0)
               {if(Cmd==OP_BUY) sl=OrderOpenPrice()-StopLoss*Point;
                if(Cmd==OP_SELL) sl=OrderOpenPrice()+StopLoss*Point;}
             if(TakeProfit>0 && tp==0)
               {if(Cmd==OP_BUY) tp=OrderOpenPrice()+TakeProfit*Point;
                if(Cmd==OP_SELL) tp=OrderOpenPrice()-TakeProfit*Point;}
             if(OrderModify(tick,OrderOpenPrice(),sl,tp,0,CLR_NONE)) break;}}
   }
    Print("#",er,"  Error: ",GetLastError()," Function: NewOrder(",Cmd,",",lot,",",pr,",",tp,",",sl,")");
    Sleep(1000);}
return(tick);}
//+------------------------------------------------------------------+
void DelOrder()
{for(int er=0;er<3;er++)
  {while(!IsTradeAllowed()) Sleep(100);
   if(OrderDelete(OrderTicket(),CLR_NONE)) break;
   Print("#",er,"  Error: ",GetLastError()," Function: DelOrder()");
   Sleep(1000);}}
//+------------------------------------------------------------------+
double NormLot(double lot)
{double Min_Lot=MarketInfo(Symbol(),MODE_MINLOT);
 double Max_Lot=MarketInfo(Symbol(),MODE_MAXLOT);
 double Step   =MarketInfo(Symbol(),MODE_LOTSTEP);
 int    DigLot =0;
 if(Step<0.1)  DigLot=2;
 if(Step>=0.1) DigLot=1;
 if(Step>=1)   DigLot=0;
 if(lot<Min_Lot) lot=Min_Lot;
 if(lot>Max_Lot) lot=Max_Lot;
return(NormalizeDouble(lot,DigLot));}
//+------------------------------------------------------------------+
double GetOptimalLot(int Percent)
{double Free    =AccountFreeMargin();
 double One_Lot =MarketInfo(Symbol(),MODE_MARGINREQUIRED);
 double Step    =MarketInfo(Symbol(),MODE_LOTSTEP);
 double Lots_New=MathFloor(Free*Percent/100/One_Lot/Step)*Step;
return(NormLot(Lots_New));}
//+------------------------------------------------------------------+